// 
// 
// 

#include "ADConversion.h"

void ADConversion::init()
{
	started = false;

}
//prepare registry for AD conversion, start AD conversion
void ADConversion::start()
{
	ADMUX = 0;
	//pouzi vstup ADC2 (pin 3)
	ADMUX |= (1 << MUX1);
	//pouzi ext ref na Aref pine (pin 5)
	ADMUX |= (1 << REFS0);
		/*Clock   Available prescaler values
		-------------------------------------- -
		1 MHz   8 (125kHz), 16 (62.5kHz)  - bity 1 0 0*/
	// pouzijem 62.5kHz
	ADCSRA =
		(1 << ADEN) |     // Enable ADC 
		(1 << ADPS2) |     // set prescaler to 16, bit 2 
		(0 << ADPS1) |     // set prescaler to 16, bit 1 
		(0 << ADPS0);      // set prescaler to 16, bit 0  
	//start ADC conversion
	ADCSRA |= (1 << ADSC);
	//mark flag conversion was started
	started = true;
}

bool ADConversion::isConverting()
{
	return started && bit_is_set(ADCSRA, ADSC);
}

int ADConversion::getMeasuredValue()
{
	if ((started) && (!isConverting()))
	{
		//read result
		uint8_t low = ADCL; // must read ADCL first - it then locks ADCH  
		uint8_t high = ADCH; // unlocks both

		int result = (high << 8) | low;
		return result;
	}
	else //no measurement data
		return -1;
}


//ADConversionClass ADConversion;

